Skip to main content

Prefix Sum of 2D matrix code

 Today we will see the code to get Prefix sum matrix of a 2D matrix .


We calculate the prefix sum by changing the matrix in-place.

For the 0th row and column, prefix sum can be easily calculated by adding the previous sum to the element.
For the other cells, we can find the prefix sum as:

  1. Add the prefix sum of the cell just above and left to it.
  2. Subtract the prefix sum of the cell on the top-left diagonal cell. We do this because we have added this prefix sum in each of the top and left cell of the given cell. Therefore, we have to subtract it once.


Fig.Getting prefix sum






Code : 

for(int i=0; i<row; i++){
            for(int j=0; j<col; j++){
                if(i>0) grid[i][j] += grid[i-1][j];
                if(j>0) grid[i][j] += grid[i][j-1];
                if(i>0 && j>0) grid[i][j] -= grid[i-1][j-1];

               
            }
        }

Related question for practice : 


https://leetcode.com/problems/count-submatrices-with-top-left-element-and-sum-less-than-k/description/


Comments

Popular posts from this blog

[PDF DOWNLOAD] AKTU Quantum series data structure b.tech 2nd year download

  All AKTU Quantums are available here. Get your hands on AKTU Quantums and boost your grades in AKTU semester exams. You can either search them category wise or can use the search bar or can manually search on this page. Download aktu second year quantum pdf data structures  download  data structures quantum aktu download aktu data structures quantum click here to download  write in comment section if you want quantum of any other subject.

solution : Snape and Ladder | codechef | Problem Code: SNAPE

  Snape and Ladder  Problem Code:  SNAPE Professor Snape has lots of potions. Bottles containing all types of potions are stacked on shelves which cover the entire wall from floor to ceiling. Professor Snape has broken his bones several times while climbing the top shelf for retrieving a potion. He decided to get a ladder for him. But he has no time to visit Diagon Alley. So he instructed Ron Weasley to make a ladder for him. Professor Snape specifically wants a step ladder which looks like an inverted 'V' from side view. Professor just mentioned two things before vanishing- B  - separation between left side (LS) and right side (RS) on the ground LS  - the length of left side What should be the length of  RS ? At one extreme  LS  can be vertical and at other  RS  can be vertical. Ron is angry and confused. Since Harry is busy battling Voldemort, its your duty to help him find the minimum and maximum length of  RS . Input First line contains single integer  T , the number of tes

solution: Count Total Set Bits | interviewbit | Amazon previous year problems

  Problem Description Given a positive integer A , the task is to count the total number of set bits in the binary representation of all the numbers from 1 to A . Return the count modulo 10 9 + 7 . Problem Constraints 1 <= A <= 10 9 Input Format First and only argument is an integer A . Output Format Return an integer denoting the ( Total number of set bits in the binary representation of all the numbers from 1 to A )modulo 10 9 + 7 . Example Input Input 1: A = 3 Input 2: A = 1 Example Output Output 1: 4 Output 2: 1 Example Explanation Explanation 1: DECIMAL BINARY SET BIT COUNT 1 01 1 2 10 1 3 11 2 1 + 1 + 2 = 4 Answer = 4 % 1000000007 = 4 Explanation 2: A = 1 DECIMAL BINARY SET BIT COUNT 1 01 1 Answer = 1 % 1000000007 = 1 solution : int  Solution::solve ( int  A )   {      if ( A  ==   0 )      {          return   0 ;      }      if ( A  == 1    )      {          return   1